using System;

namespace iAnywhere.Data.UltraLite.CustomDataSet {

    /// <summary><para>Contains the values of a table row. This class stores
    /// all data-types as objects. Since C# does implicit boxing/unboxing, this
    /// is possible even for native types.</para><summary>
    internal class CustomTableRow
    {
	private Object [] _dataItems;

	// constructor
	internal CustomTableRow( int numColumns ) {
	    _dataItems = new Object[numColumns];
	    for( int i = 0; i < numColumns; i++ ) _dataItems[i] = null;
	}

	// the indexer for this class. Retrieves/sets the correct column value within
	// the row.
	public Object this[ int index ] {
	    get {
		if( index < 0 || index >= _dataItems.Length ) {
		    throw new ArgumentOutOfRangeException();
		}
		return _dataItems[index];
	    }
	    set {
		if( index < 0 || index >= _dataItems.Length ) {
		    throw new ArgumentOutOfRangeException();
		}
		_dataItems[index] = value;
	    }
	}
    }
}
